<?php

/*
Written by Chris Jean for iThemes.com
Version 2.2.1

Version History
	See history.txt
*/



if ( ! class_exists( 'LayoutModuleHTML' ) ) {
	class LayoutModuleHTML extends LayoutModule {
		var $_name = 'HTML';
		var $_var = 'html';
		var $_description = 'This module gives you a place to add freeform HTML to the layout. It also supports the use of shortcodes and execution of PHP code.';
		var $_editor_width = 700;
		var $_can_remove_wrappers = true;
		
		
		function _get_defaults( $defaults ) {
			$new_defaults = array(
				'html'			=> '',
				'sidebar'		=> '',
				'enable_eval'	=> 'no',
			);
			
			return ITUtility::merge_defaults( $new_defaults, $defaults );
		}
		
		function _before_table_edit( $form, $results = true ) {
			
?>
	<p>This module isn't limited to just static HTML content. You can also use shortcodes and PHP code to add generated content. PHP support must first be activated with the Enable PHP option below.</p>
	<p>Using shortcodes is preferred over PHP code as allowing PHP code has security risks.</p>
<?php
			
		}
		
		function _start_table_edit( $form, $results = true ) {
			
?>
	<tr><td><label for="html">HTML</label></td>
		<td><?php $form->add_text_area( 'html', array( 'cols' => '55', 'rows' => '10' ) ); ?></td>
	</tr>
<?php
			
		}
		
		function _end_table_edit( $form, $results = true ) {
			
?>
	<tr><td><label for="enable_eval">Enable PHP</label></td>
		<td>
			<?php $form->add_drop_down( 'enable_eval', array( 'no' => 'No', 'yes' => 'Yes' ) ); ?><br />
			Enabling this option allows for processing of PHP code inside the module. <strong>Always review the PHP code if taken from a third party as it could pose a serious security threat.</strong>
		</td>
	</tr>
<?php
			
		}
		
		function _render( $fields ) {
			$data = $fields['data'];
			
			$html = do_shortcode( $data['html'] );
			
			if ( isset( $data['enable_eval'] ) && ( 'yes' === $data['enable_eval'] ) )
				eval( "?>$html" );
			else
				echo $html;
		}
	}
	
	new LayoutModuleHTML();
}


?>
